import com.danitheskunk.skunkworks.*;
import com.danitheskunk.skunkworks.windows.*;
import com.sun.jna.Pointer;
import com.sun.jna.platform.win32.User32;
import com.sun.jna.platform.win32.WinDef;
import com.sun.jna.platform.win32.WinUser;

import java.util.ArrayList;

public class Test {
	public static void main(String[] args) {
		var windows = Window.getAllVisible();

		System.out.printf("%d Open Windows:\n", windows.size());
		for(var window: windows) {
			System.out.printf("%s -- %s -- %s\n", window.getTitle(), window.getClassName(), window.getExecutableName());
		}
		windows.get(0).setBorder(true);
		windows.get(0).setBorderRounded(false);
		windows.get(0).move(new Recti(1280, 720, 2560, 1440));
		windows.get(0).debugPrintStyles();
		windows.get(0).debugPrintStylesEx();
		Window.onKey();
		Window.onNewWindow();
		Window.messageLoop();
		/*
		var engine = new Engine();
		var window = engine.openWindow(new Vec2i(1280, 720), "Skunkworks");
		var img = engine.loadImage("C:\\Users\\dani\\Videos\\Screenshot 2022-06-25 17-00-59.png");
		var tex2 = window.loadTexture("C:\\art\\pixel stuff.png");
		var tileset = window.loadTextureArray("C:\\stream\\coding\\rlc\\tilemap.png", new Vec2i(16, 16));
		var font = window.loadFontTileset("EGA8x14.png");
		var font2 = window.loadFontTTF("fonts\\LiberationSans-Regular.ttf", 16*8.f);
		//img.drawImage(img2, Vec2i.ZERO);
		var tex = window.loadTexture(img);
		window.setDebug(true);

		while(!window.shouldClose()) {
			window.tick();
			var renderContext = window.renderStart();
			renderContext.drawTextureRectangle(
				new Recti(0, 0, 1280, 720),
				tex
			);
			renderContext.drawTextureRectangle(
				new Recti(new Vec2i(200, 100), tex2.getSize()),
				tex2
			);

			renderContext.drawTextureRectangle(
				new Recti(new Vec2i(400, 400), new Vec2i(16, 16)),
				tileset.get(0x30)
			);

			renderContext.drawString(new Vec2i(100, 100), "hello world mew", font);
			renderContext.drawString(new Vec2i(710, 140), "hello world mew", font2);
			window.renderFinish(renderContext);
		}
		 */
	}
}
